#ifndef SMSubataWrapper_WRAPPER_HEADER_H
#define SMSubataWrapper_WRAPPER_HEADER_H

#include "sub/SubDataWrapper.h"
#include "dpc_sm/executable.h"


// TODO: an event for can should be added here

template <typename DataType>
class DM2SM_SubDataWrapper : public SubDataWrapper<DataType>
{
    private:
        dpc::Decision4SM* _sm_Decision4SM = nullptr;
    public:
        void Process(ara::com::SamplePtr<DataType const>* ptr) override
        {
            _sm_Decision4SM = (dpc::Decision4SM*)ptr->Get();
        }
        void GetData(dpc::Decision4SM &data){
            if(_sm_Decision4SM)
                data = *(_sm_Decision4SM);
        }
    
}; 

template <typename DataType>
class VED2SM_SubDataWrapper : public SubDataWrapper<DataType>
{
    private:
        dpc::VED4DPC* _sm_VED4DPC = nullptr;
    public:
        void Process(ara::com::SamplePtr<DataType const>* ptr) override
        {
            _sm_VED4DPC = (dpc::VED4DPC*)ptr->Get();
        }
        void GetData(dpc::VED4DPC &data){
            if(_sm_VED4DPC)
                data = *(_sm_VED4DPC);
        }
    
}; 

template <typename DataType>
class DM2SMObjectTrim_SubDataWrapper : public SubDataWrapper<DataType>
{
    private:
        dpc::ObjectTrim* _sm_ObjectTrim = nullptr;
    public:
        void Process(ara::com::SamplePtr<DataType const>* ptr) override
        {
            _sm_ObjectTrim = (dpc::ObjectTrim*)ptr->Get();
        }
        void GetData(dpc::ObjectTrim &data){
            if(_sm_ObjectTrim)
                data = *(_sm_ObjectTrim);
        }
    
}; 

template <typename DataType>
class EM2SMLaneInfo_SubDataWrapper : public SubDataWrapper<DataType>
{
    private:
        dpc::LaneInfo* _sm_LaneInfo = nullptr;
    public:
        void Process(ara::com::SamplePtr<DataType const>* ptr) override
        {
            _sm_LaneInfo = (dpc::LaneInfo*)ptr->Get();
        }
        void GetData(dpc::LaneInfo &data){
            if(_sm_LaneInfo)
                data = *(_sm_LaneInfo);
        }
    
}; 

template <typename DataType>
class EM2SMLeftLine_SubDataWrapper : public SubDataWrapper<DataType>
{
    private:
        dpc::LeftLine* _sm_LeftLine = nullptr;
    public:
        void Process(ara::com::SamplePtr<DataType const>* ptr) override
        {
            _sm_LeftLine = (dpc::LeftLine*)ptr->Get();
        }
        void GetData(dpc::LeftLine &data){
            if(_sm_LeftLine)
                data = *(_sm_LeftLine);
        }
    
}; 

template <typename DataType>
class EM2SMLeftRoadEdge_SubDataWrapper : public SubDataWrapper<DataType>
{
    private:
        dpc::LeftRoadEdge* _sm_LeftRoadEdge = nullptr;
    public:
        void Process(ara::com::SamplePtr<DataType const>* ptr) override
        {
            _sm_LeftRoadEdge = (dpc::LeftRoadEdge*)ptr->Get();
        }
        void GetData(dpc::LeftRoadEdge &data){
            if(_sm_LeftRoadEdge)
                data = *(_sm_LeftRoadEdge);
        }
    
}; 

template <typename DataType>
class EM2SMODDInfo_SubDataWrapper : public SubDataWrapper<DataType>
{
    private:
        dpc::ODDInfo* _sm_ODDInfo = nullptr;
    public:
        void Process(ara::com::SamplePtr<DataType const>* ptr) override
        {
            _sm_ODDInfo = (dpc::ODDInfo*)ptr->Get();
        }
        void GetData(dpc::ODDInfo &data){
            if(_sm_ODDInfo)
                data = *(_sm_ODDInfo);
        }
    
}; 

template <typename DataType>
class EM2SMRMEgoLftLnegeometry_SubDataWrapper : public SubDataWrapper<DataType>
{
    private:
        dpc::RMEgoLftLnegeometry* _sm_RMEgoLftLnegeometry = nullptr;
    public:
        void Process(ara::com::SamplePtr<DataType const>* ptr) override
        {
            _sm_RMEgoLftLnegeometry = (dpc::RMEgoLftLnegeometry*)ptr->Get();
        }
        void GetData(dpc::RMEgoLftLnegeometry &data){
            if(_sm_RMEgoLftLnegeometry)
                data = *(_sm_RMEgoLftLnegeometry);
        }
    
}; 

template <typename DataType>
class EM2SMRMEgoRgtLnegeometry_SubDataWrapper : public SubDataWrapper<DataType>
{
    private:
        dpc::RMEgoRgtLnegeometry* _sm_RMEgoRgtLnegeometry = nullptr;
    public:
        void Process(ara::com::SamplePtr<DataType const>* ptr) override
        {
            _sm_RMEgoRgtLnegeometry = (dpc::RMEgoRgtLnegeometry*)ptr->Get();
        }
        void GetData(dpc::RMEgoRgtLnegeometry &data){
            if(_sm_RMEgoRgtLnegeometry)
                data = *(_sm_RMEgoRgtLnegeometry);
        }
    
}; 

template <typename DataType>
class EM2SMRMRdEdgeLftgeometry_SubDataWrapper : public SubDataWrapper<DataType>
{
    private:
        dpc::RMRdEdgeLftgeometry* _sm_RMRdEdgeLftgeometry = nullptr;
    public:
        void Process(ara::com::SamplePtr<DataType const>* ptr) override
        {
            _sm_RMRdEdgeLftgeometry = (dpc::RMRdEdgeLftgeometry*)ptr->Get();
        }
        void GetData(dpc::RMRdEdgeLftgeometry &data){
            if(_sm_RMRdEdgeLftgeometry)
                data = *(_sm_RMRdEdgeLftgeometry);
        }
    
}; 

template <typename DataType>
class EM2SMRMRdEdgeRgtgeometry_SubDataWrapper : public SubDataWrapper<DataType>
{
    private:
        dpc::RMRdEdgeRgtgeometry* _sm_RMRdEdgeRgtgeometry = nullptr;
    public:
        void Process(ara::com::SamplePtr<DataType const>* ptr) override
        {
            _sm_RMRdEdgeRgtgeometry = (dpc::RMRdEdgeRgtgeometry*)ptr->Get();
        }
        void GetData(dpc::RMRdEdgeRgtgeometry &data){
            if(_sm_RMRdEdgeRgtgeometry)
                data = *(_sm_RMRdEdgeRgtgeometry);
        }
    
}; 

template <typename DataType>
class EM2SMRMSMMessage_SubDataWrapper : public SubDataWrapper<DataType>
{
    private:
        dpc::RMSMMessage* _sm_RMSMMessage = nullptr;
    public:
        void Process(ara::com::SamplePtr<DataType const>* ptr) override
        {
            _sm_RMSMMessage = (dpc::RMSMMessage*)ptr->Get();
        }
        void GetData(dpc::RMSMMessage &data){
            if(_sm_RMSMMessage)
                data = *(_sm_RMSMMessage);
        }
    
}; 

template <typename DataType>
class EM2SMRightLine_SubDataWrapper : public SubDataWrapper<DataType>
{
    private:
        dpc::RightLine* _sm_RightLine = nullptr;
    public:
        void Process(ara::com::SamplePtr<DataType const>* ptr) override
        {
            _sm_RightLine = (dpc::RightLine*)ptr->Get();
        }
        void GetData(dpc::RightLine &data){
            if(_sm_RightLine)
                data = *(_sm_RightLine);
        }
    
}; 

template <typename DataType>
class EM2SMRightRoadEdge_SubDataWrapper : public SubDataWrapper<DataType>
{
private:
    dpc::RightRoadEdge* _sm_RightRoadEdge = nullptr;
public:
    void Process(ara::com::SamplePtr<DataType const>* ptr) override
    {
        _sm_RightRoadEdge = (dpc::RightRoadEdge*)ptr->Get();
    }
    void GetData(dpc::RightRoadEdge &data){
        if(_sm_RightRoadEdge)
            data = *(_sm_RightRoadEdge);
    }
};

/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename DataType>
class CAN2SM_SubDataWrapper :  public SubDataWrapper<DataType>
{
private:
    CAN2SWC* _sm_CAN2SWC = nullptr;
public:
    void Process(ara::com::SamplePtr<DataType const>* ptr) override
    {
        _sm_CAN2SWC = (CAN2SWC*)ptr->Get();
    }

    void GetData(CAN2SWC &data){
        if(_sm_CAN2SWC)
            data = *(_sm_CAN2SWC);
    }
}; 


#endif
